# Python module
""" clock.py -- asynchronous update of label containing a digital clock

This is done using gtk_timeout_add: every second or so, the time is fetched,
the new label is computed, and it changed since last time, the label is
updated.
"""

from time import time, localtime, strftime
from _gtk import gtk_timeout_add, gtk_timeout_remove, gtk_label_set_text
import settings

current = time ()

class Clock :
    def __init__ (self, label) :
        self.label = label
        self.last = None
        self.update ()
        self.timer = gtk_timeout_add (settings.clockUpdate, self.update ,())

    def destroy (self) :
        if self.timer is not None :
            gtk_timeout_remove (self.timer)
            self.timer = None

    def update (self) :
        global current
        current = time ()
        loc = localtime (current)
        res = strftime (settings.clockFormat, loc)
        if res != self.last :
            self.last = res
            gtk_label_set_text (self.label, res)
        return 1 # continue

create = Clock

